#include "CAnleger.h"

//////////////////////////////////////////////////////////////////////////////////
//					CAnleger - Rahmenklasse fr das Spiel							//
//////////////////////////////////////////////////////////////////////////////////
CAnleger::CAnleger(short screen_breite, short screen_hoehe, bool fullscreen)
{
	// Zufallszahlengenerator starten
	srand((unsigned)time( NULL ));

	// Fenster erzeugen
	screen = SDL_SetVideoMode(screen_breite,screen_hoehe,0,SDL_HWSURFACE|SDL_DOUBLEBUF);
	if(!screen)
	{
		fprintf(stderr,"Konnte Bildschirmmodus nicht setzten: %s\n",SDL_GetError());
		exit(1);
	}

	// Titel setzten
	SDL_WM_SetCaption("Anleger","Anleger");

	// Pointer fr den Screen an die Karten
	CSpielkarte::setScreen(screen);

	// Kartenhintergrund laden
	SDL_Surface *tmp=0;
	tmp = IMG_Load("karten/hint.png");
	if (!tmp)
	{
		fprintf(stderr,"Konnte Kartengrafik Hintergrund nicht laden: %s\n",SDL_GetError());
		exit(1);
	}
	CSpielkarte::setBack(SDL_DisplayFormat(tmp));
	SDL_FreeSurface(tmp);

	// Spielkarten laden
	spielkarten=0;
	karten_laden();

	// Karten in den Kartenstapel
	int i,j;
	for(i=0;i<4;i++)
		for(j=0;j<SPK_WERT_ASS+1;j++)
			kartenstapel.getKarte(spielkarten[i][SPK_WERT_ASS-j]);

	kartenstapel.setAnzeige(400,300-KARTENHOEHE/2,true,true,true,-3);

	player=0;

	status=ST_SPIEL_INIT;
}

CAnleger::~CAnleger()
{
	int i,j;

	// Spieler wieder freigeben
	for(i=0;i<anz_player;i++)
		delete player[i];
	delete [] player;

	// Spielkarten wieder freigeben
	for(i=0;i<4;i++)
	{
		// Karten freigeben
		for(j=0; j<SPK_WERT_ASS+1; j++)
			delete spielkarten[i][j];

		// array freigeben
		delete [] spielkarten[i];
	}
	delete [] spielkarten;

	// Grafik fr Kartenhintergrund wieder freigeben
	CSpielkarte::delBack();
}


bool CAnleger::tick()
{
	switch(status)
	{
	case ST_SPIEL_INIT:
		status=ST_ANZAHL_SPIELER;
		break;

	case ST_ANZAHL_SPIELER:
		// zu testzwecken automatisch
		// anfrage wieviel spieler es denn sein sollen
		anz_player=3;
		spielgeber=0;
		status=ST_SPIELER_ERZEUGEN;
		break;

	case ST_SPIELER_ERZEUGEN:
		spieler_erzeugen();
		status=ST_KARTEN_GEBEN;
		break;

	case ST_KARTEN_GEBEN:
		activ_player=spielgeber; 
		karten_geben();
		status=ST_SPIELER_AKTIV;
		break;

	case ST_SPIELER_AKTIV: break;

	case ST_NEXT_SPIELER:
		set_next_player();
		status=ST_SPIELER_AKTIV;
		break;

	case ST_RUNDENENDE:
		runde_abrechnen();
		status=ST_NOCHNERUNDE;
		break;

	case ST_NOCHNERUNDE:
		break;

	case ST_SPIEL_NEU_GEBEN:

		status=ST_KARTEN_GEBEN;
		break;
	}

	zeichnen();

	return true;
}

void CAnleger::zeichnen()
{
	// Hintergrund wei
	SDL_FillRect(screen,0,-1);

	// Kartenstapel zeichnen
	kartenstapel.zeichnen();

	// Spielmitte zeichnen
	mitte.zeichnen();

	// Spieler zeichnen
	if(player)
		for(int i=0;i<anz_player;i++)
			player[i]->zeichnen();

	// das Bild auf den Bildschirm bringen
	SDL_Flip(screen);
}

void CAnleger::click(int x, int y)
{
	if(status==ST_SPIELER_AKTIV)
	{
		CSpielkarte* karte=player[activ_player]->click(x,y);
		if(karte)
		{
			if(mitte.getKarte(karte))
			{
				SDL_WM_SetCaption("Karte kann nicht abgelegt werden","Karte kann nicht abgelegt werden");
			}
			else
			{
				player[activ_player]->giveKarte(karte);
				SDL_WM_SetCaption("Karte abgelegt","Karte abgelegt");
				// Testen ob Spielende
				if(!player[activ_player]->getAnzKarten()) status=ST_RUNDENENDE;
				else status=ST_NEXT_SPIELER;
			}
		}
		else
		{
			player[activ_player]->holzen();
			SDL_WM_SetCaption("Geholzt",0);
			status=ST_NEXT_SPIELER;
		}
	}
	else if(status==ST_NOCHNERUNDE)
		status=ST_SPIEL_NEU_GEBEN;
}

void CAnleger::karten_laden()
{
	char* datei = new char[100];	// pfad mit dateiname
	char* f = new char[10];			// farbe
	char* d = new char[10];			// dateiname

	// array fr die Karten erzeugen
	spielkarten= new CSpielkarte**[4];

	for(int i=0;i<4;i++)
	{
		spielkarten[i]= new CSpielkarte*[SPK_WERT_ASS+1];

		// Farbe fr Pfad bestimmen
		switch (i)
		{
		case SPK_FARBE_EICHEL:	sprintf(f,"eichel");	break;
		case SPK_FARBE_GRUEN:	sprintf(f,"gruen");		break;
		case SPK_FARBE_HERZ:	sprintf(f,"herz");		break;
		case SPK_FARBE_SCHELLEN:sprintf(f,"schellen");	break;
		}

		for(int j=0;j<SPK_WERT_ASS+1;j++)
		{
			// Datei bestimmen
			switch(j)
			{
			case SPK_WERT_7:		sprintf(d,"7");		break;
			case SPK_WERT_8:		sprintf(d,"8");		break;
			case SPK_WERT_9:		sprintf(d,"9");		break;
			case SPK_WERT_10:		sprintf(d,"10");	break;
			case SPK_WERT_UNTER:	sprintf(d,"unter");	break;
			case SPK_WERT_OBER:		sprintf(d,"ober");	break;
			case SPK_WERT_KOENIG:	sprintf(d,"koenig");break;
			case SPK_WERT_ASS:		sprintf(d,"ass");	break;
			}
			sprintf(datei,"karten/%s/%s.png",f,d);

			// Karte erzeugen
			spielkarten[i][j]= new CSpielkarte(i,j,datei);
		}
	}

	// speicher fr dateinamen/pfad wieder freigeben
	delete [] d;
	delete [] f;
	delete [] datei;
}


void CAnleger::spieler_erzeugen()
{
	// array fr die Spieler
	player= new CPlayer*[anz_player];

	// die spieler erzeugen
	for(int i=0;i<anz_player;i++)
		player[i]=new CPlayer;

	// Anzeiger der Spieler einstellen
	player[0]->setAnzeige(400,600-KARTENHOEHE,true,false,false,2*KARTENBREITE/3);

	// zu debug-zwecken
	bool verdeckt=false;

	switch(anz_player)
	{
	case 3:
		player[1]->setAnzeige(10,300,true,verdeckt,true);
		player[2]->setAnzeige(790-KARTENBREITE,300,true,verdeckt,true);
		break;

	case 4:
		player[1]->setAnzeige(10,300,true,verdeckt,true);
		player[2]->setAnzeige(400,0,true,verdeckt,false,2+KARTENBREITE/3);
		player[3]->setAnzeige(790-KARTENBREITE,300,true,verdeckt,true);
		break;

	case 5:
		player[1]->setAnzeige(10,300,true,verdeckt,true);
		player[2]->setAnzeige(200,0,true,verdeckt,false,2*KARTENBREITE/3);
		player[3]->setAnzeige(600,0,true,verdeckt,false,2*KARTENBREITE/3);
		player[4]->setAnzeige(790-KARTENBREITE,300,true,verdeckt,true);
		break;

	case 6:
		player[1]->setAnzeige(10,450,true,verdeckt,true);
		player[2]->setAnzeige(10,150,true,verdeckt,true);
		player[3]->setAnzeige(400,0,true,verdeckt,false,2*KARTENBREITE/3);
		player[4]->setAnzeige(790-KARTENBREITE,150,true,verdeckt,true);
		player[5]->setAnzeige(790-KARTENBREITE,450,true,verdeckt,true);
		break;

	case 7:
		player[1]->setAnzeige(10,450,true,verdeckt,true);
		player[2]->setAnzeige(10,150,true,verdeckt,true);
		player[3]->setAnzeige(200,0,true,verdeckt,false);
		player[4]->setAnzeige(600,0,true,verdeckt,false);
		player[5]->setAnzeige(790-KARTENBREITE,150,true,verdeckt,true);
		player[6]->setAnzeige(790-KARTENBREITE,450,true,verdeckt,true);
		break;
	}
	
}


void CAnleger::karten_geben()
{
	// Karten michen
	//kartenstapel.mixKarten(10);

	int karten=0;
	int i,j;

	switch(anz_player)
	{
	case 3: karten=10; break;	// 2 brig
	case 4: karten= 8; break;	// keine brig
	case 5: karten= 6; break;	// 2 brig
	case 6: karten= 5; break;	// 2 brig
	case 7: karten= 4; break;	// 4 brig
	}

	// Karten an die Spieler geben
	for(i=0;i<anz_player;i++)
		for(j=0;j<karten;j++) player[i]->getKarte(kartenstapel.giveFirstKarte());

	// Restkarten verteilen
	int activ_player_org=activ_player;
	switch(anz_player)
	{
	case 3:
	case 5:
	case 6:
		for(i=0;i<2;i++)
		{
			set_next_player();
			player[activ_player]->getKarte(kartenstapel.giveFirstKarte());
		}
		activ_player=activ_player_org;
		break;
	case 7:
		for(i=0;i<4;i++)
		{
			set_next_player();
			player[activ_player]->getKarte(kartenstapel.giveFirstKarte());
		}
		activ_player=activ_player_org;
		break;
	}

	for(i=0;i<anz_player;i++)
		player[i]->sortKarten();
}

void CAnleger::set_next_player()
{
	activ_player++;
	if(activ_player==anz_player) activ_player=0;
}

void CAnleger::runde_abrechnen()
{
	int sieger=activ_player;
	int punkte=0;

	// Karten aus der mitte zurckholen
	CSpielkarte* karte=0;
	while(karte=mitte.giveKarte()) kartenstapel.getKarte(karte);

	// Karten der Spieler hohlen
	for(int i=0;i<anz_player;i++)
	{
		punkte=0;

		if (i==sieger) continue;

		while(karte=player[i]->giveKarte(0))
		{
			kartenstapel.getKarte(karte);
			punkte++;
		}
		punkte+=player[i]->getHolze();
		player[sieger]->addPunkte(punkte);
		player[i]->addPunkte(-punkte);
		player[i]->delHolze();
	}

	// neuen spielgeber bestimmen
	spielgeber++;
	if(spielgeber==anz_player) spielgeber=0;

}