// CSpielkarte.cpp: Implementierung der Klasse CSpielkarte.
//
//////////////////////////////////////////////////////////////////////

#include "CSpielkarte.h"

//////////////////////////////////////////////////////////////////////
// Startwerte fr die Statischen Variablen
//////////////////////////////////////////////////////////////////////
SDL_Surface* CSpielkarte::screen=0;
SDL_Surface* CSpielkarte::back=0;

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CSpielkarte::CSpielkarte(int farbe, int wert, char* datei)
{
	// Werte bernehmen
	this->farbe=farbe;
	this->wert=wert;

	// Grafik laden
	SDL_Surface *tmp=0;
	tmp = IMG_Load(datei);
	if (!tmp)
	{
		fprintf(stderr,"Konnte Kartengrafik nicht laden: %s\n",SDL_GetError());
		exit(1);
	}
	grafik = SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	
	// Ausmae der Karte ermitteln
	this->w=grafik->w;
	this->h=grafik->h;
}

CSpielkarte::~CSpielkarte()
{
	// Grafik wieder freigeben
	SDL_FreeSurface(grafik);
	
}

//////////////////////////////////////////////////////////////////////
// Karte zeichnen
//////////////////////////////////////////////////////////////////////
void CSpielkarte::zeichnen(bool back)
{
	if((screen)&&(grafik))
	{
		if(back)
		{
			// zeichne hintergrundgrafik
			SDL_BlitSurface(this->back,0,screen,&pos);
		}
		else
		{
			// zeichne kartengrafik
			SDL_BlitSurface(grafik,0,screen,&pos);
		}
	}
}

//////////////////////////////////////////////////////////////////////
// Prfen ob der Klick auf die Karte ging
//////////////////////////////////////////////////////////////////////
bool CSpielkarte::click(int x, int y)
{
	if ((x>=pos.x)&&(x<pos.x+w))
		if((y>=pos.y)&&(y<pos.y+h))
			return true;

	return false;
}

//////////////////////////////////////////////////////////////////////
// Getter/Setter
//////////////////////////////////////////////////////////////////////
void CSpielkarte::setScreen(SDL_Surface* screen)
{
	CSpielkarte::screen=screen;
}

void CSpielkarte::setBack(SDL_Surface* back)
{
	CSpielkarte::back=back;
}

void CSpielkarte::delBack()
{
	if(CSpielkarte::back)
	{
		SDL_FreeSurface(CSpielkarte::back);
		CSpielkarte::back=0;
	}
}

void CSpielkarte::setpos(int x, int y)
{
	pos.x=x;
	pos.y=y;
}
	
int CSpielkarte::getWert()
{
	return wert;
}

int CSpielkarte::getFarbe()
{
	return farbe;
}