// CSpielkarte.h: Schnittstelle fr die Klasse CSpielkarte.
//
//////////////////////////////////////////////////////////////////////

#if !defined(HEADER_SPIELKARTE)
#define HEADER_SPIELKARTE

// includes
#include <stdlib.h>
#include <stdio.h>
#include <sdl.h>
#include <sdl_image.h>

// Definition der Spielkartenwerte
#define SPK_FARBE_EICHEL	0
#define SPK_FARBE_GRUEN		1
#define SPK_FARBE_HERZ		2
#define SPK_FARBE_SCHELLEN	3

#define SPK_WERT_7		0
#define SPK_WERT_8		1
#define SPK_WERT_9		2
#define SPK_WERT_10		3
#define SPK_WERT_UNTER	4
#define SPK_WERT_OBER	5
#define SPK_WERT_KOENIG	6
#define SPK_WERT_ASS	7

#define KARTENBREITE	75
#define KARTENHOEHE		114


class CSpielkarte 
{
public:
	CSpielkarte(int farbe, int wert, char* datei);
	virtual ~CSpielkarte();
	
	static void setScreen(SDL_Surface* screen);	// Pointer zum Screen angeben
	static void setBack(SDL_Surface* back);		// Kartenhintergrund
	static void delBack();

	bool click(int x, int y);	// liegt der Klick auf der Karte

	int getWert();				// gibt den Wert der Karte zurck
	int getFarbe();				// gibt die Farbe der karte zurck
	void setpos(int x, int y);	// Position der Spielkarte auf dem Bildschrim ndern
	void zeichnen(bool back);	// Spielkarte zeichnen

private:
	int farbe;	// Farbe der Karte;
	int wert;	// Wert der Karte
	SDL_Rect pos;	// Position auf dem Bildschirm
	int w,h;	// Hoehe, Breite der Kartengrafik

	SDL_Surface* grafik;
	static SDL_Surface* screen;
	static SDL_Surface* back;
};

#endif
