// CSpielmitte.cpp: Implementierung der Klasse CSpielmitte.
//
//////////////////////////////////////////////////////////////////////

#include "CSpielmitte.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CSpielmitte::CSpielmitte()
{
	startwert=-1;
}

CSpielmitte::~CSpielmitte()
{

}

//////////////////////////////////////////////////////////////////////
// Mit dieser Karte wird das Spiel begonnen
//////////////////////////////////////////////////////////////////////
void CSpielmitte::getStartkarte(CSpielkarte* karte)
{
	startwert=karte->getWert();
	stapel[karte->getFarbe()].getKarte(karte);

	// anzeige anpassen
	if((startwert==SPK_WERT_ASS)||(startwert==0))
	{
		stapel[SPK_FARBE_EICHEL  ].setAnzeige(400-3*KARTENBREITE/2,300-(5*KARTENHOEHE/4),false,false,false,0);
		stapel[SPK_FARBE_GRUEN   ].setAnzeige(400+KARTENBREITE/2,300-(5*KARTENHOEHE/4),false,false,false,0);
		stapel[SPK_FARBE_HERZ    ].setAnzeige(400-3*KARTENBREITE/2,300+KARTENHOEHE/4,false,false,false,0);
		stapel[SPK_FARBE_SCHELLEN].setAnzeige(400+KARTENBREITE/2,300+KARTENHOEHE/4,false,false,false,0);
	}
	else
	{
		// for(int i=0;i<4;i++)
		int farbe=karte->getFarbe();
		int x=(400-4*KARTENBREITE)+((SPK_WERT_ASS - stapel[farbe].getWertHoechsteKarte(farbe))*KARTENBREITE);
		stapel[farbe].setAnzeige(x,KARTENHOEHE+10+(2*KARTENHOEHE/3)*farbe,false,false,false,KARTENBREITE);
	}
}

//////////////////////////////////////////////////////////////////////
// Es wird eine Karte ins Spielfeld gelegt
//////////////////////////////////////////////////////////////////////
CSpielkarte* CSpielmitte::getKarte(CSpielkarte* karte)
{
	if(startwert==-1)
	{
		getStartkarte(karte);
		return 0;
	}

	int wert=karte->getWert();
	int farbe=karte->getFarbe();

	if(wert==startwert) stapel[farbe].getKarte(karte);
	else if(wert<startwert)
	{
		if(wert==stapel[farbe].getWertNiedrigsteKarte(farbe)-1) stapel[farbe].getKarte(karte);
		else return karte;

	}
	else if(wert>startwert)
	{
		if(wert==stapel[farbe].getWertHoechsteKarte(farbe)+1) stapel[farbe].getKarte(karte);
		else return karte;
	}

	if((startwert<SPK_WERT_ASS)&&(startwert>0))
	{
		// Karten sortieren
		stapel[farbe].sortKarten();

		// anzeige anpassen
		int x=(400-4*KARTENBREITE)+((SPK_WERT_ASS - stapel[farbe].getWertHoechsteKarte(farbe))*KARTENBREITE);
		stapel[farbe].setAnzeige(x,KARTENHOEHE+10+(2*KARTENHOEHE/3)*farbe,false,false,false,KARTENBREITE);
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////
// Gibt die Karten aus der Spielmitte wieder zurck
//////////////////////////////////////////////////////////////////////
CSpielkarte* CSpielmitte::giveKarte()
{
	// Probiert alle Stapel durch und gibt die karten zurck
	// wenn keine Karten mehr da -> 0

	CSpielkarte* karte=0;

	for(int i=0;i<4;i++)
	{
		karte=stapel[i].giveFirstKarte();
		if(karte) return karte;
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////
// Zeichnen der Spielmitte
//////////////////////////////////////////////////////////////////////
void CSpielmitte::zeichnen()
{
	for(int i=0;i<4;i++)
		stapel[i].zeichnen();
}